function D=det(A,varargin)
  p = inputParser;
  p.KeepUnmatched=true; 
  p.addParamValue('select','auto',@(x) ismember(lower(x),{'lu','laplace','auto'}));
  p.parse(varargin{:});
  R=p.Results;
  [N,m,n]=size(A);
  assert( m == n )
  switch lower(R.select)
    case 'auto'
      if n<=5 %experimental value
        D=amat(fc_amat.detLapIdx_values(A.values));
      else
        D=fc_amat.detLU(A);
      end
    case 'lu'
      D=fc_amat.detLU(A);
    case 'laplace'
      D=amat(fc_amat.detLapIdx_values(A.values));
  end
end
